//+------------------------------------------------------------------+
//|                                              iCustomTesterEA.mq4 |
//|                          Copyright  2012, Robert Hill aka MrPip |
//|                                                                  |
//|    The EA can be quickly modified to output values returned by   |
//|    custom indicators                                             |
//+------------------------------------------------------------------+
#include <stdlib.mqh>

extern string  z0 = "--- MA in Color Inputs ---";
extern int       MAPeriod=21;
extern int       MAType=0;

extern string  to="---Text Object Settings---";
extern bool    OutputTextToChart = true;
extern int     Y_OffSet = 60;
extern int 		TxtSize = 10;
extern color 	TxtColor  = White;

int            StatusY, Comment1Y, Comment2Y, Comment3Y, Comment4Y, Comment5Y, Comment6Y, Comment7Y;
string         StatusLabel, Comment1Label, Comment2Label, Comment3Label, Comment4Label, Comment5Label, Comment6Label, Comment7Label;
double buf0, buf1, buf2, buf3, buf4, buf5, buf6;

int init()
{
    DeleteExistingLabels();
    SetupLabels();
    ClearLabels();
   return(0);
}

int deinit()
{
   ClearLabels();
   DeleteExistingLabels();
 return(0);
}


//+------------------------------------------------------------------+
//| Start function                                                   |
//+------------------------------------------------------------------+
void start()
  {
    
    
   if (Comment1Y < Y_OffSet)
   {
     SetupLabels();
     ClearLabels();
     DeleteExistingLabels();
     SetupLabels();// Make sure label settings are OK
   }
      
   if (IsTesting() == false)
   {
     if (IsExpertEnabled() == false)
     {
      OutputStatusToChart("Expert is not enabled");
      return(0);
     }
   }
      
   if (!NewBar()) return(0);
   
// Modify here to test your custom indicator calls
   double MAFlat, MADown, MAUp;
   int FlatBuffer = 0;
   int UpBuffer = 1;
   int DownBuffer = 2;

   MADown=iCustom(NULL,0,"MAInColor", MAPeriod, MAType, DownBuffer,1);
   MAUp=iCustom(NULL,0,"MAInColor", MAPeriod, MAType, UpBuffer,1);
   MAFlat=iCustom(NULL,0,"MAInColor", MAPeriod, MAType, FlatBuffer,1);

   OutputComment1ToChart("Down  " + DoubleToStr(MADown,Digits) );
   OutputComment2ToChart("Up  " + DoubleToStr(MAUp,Digits) );
   OutputComment3ToChart("Flat  " + DoubleToStr(MAFlat,Digits) );
   
   return(0);
//----
}


bool NewBar()
{
   static datetime dt = 0;
   
   if (Time[0] != dt)
   {
      dt = Time[0];
      return(true);
   }
   return(false);
}

void ClearLabels()
{
   string mComment = " ";
   
   OutputLabelToChart(StatusLabel, StatusY, TxtSize, TxtColor, mComment);
   OutputLabelToChart(Comment1Label, Comment1Y, TxtSize, TxtColor, mComment);
   OutputLabelToChart(Comment2Label, Comment2Y, TxtSize, TxtColor, mComment );
   OutputLabelToChart(Comment3Label, Comment3Y, TxtSize, TxtColor, mComment );
   OutputLabelToChart(Comment4Label, Comment4Y, TxtSize, TxtColor, mComment );
   OutputLabelToChart(Comment5Label, Comment5Y, TxtSize, TxtColor, mComment );
   OutputLabelToChart(Comment6Label, Comment6Y, TxtSize, TxtColor, mComment );
   OutputLabelToChart(Comment7Label, Comment7Y, TxtSize, TxtColor, mComment );
}

void DeleteExistingLabels()
{
   int objLabels = ObjectsTotal();
   string objName;
   
   if (objLabels > 0)
   {
      for (int i = objLabels; i >= 0;i--)
      {
         objName = ObjectName(i);
         if (StringFind(objName,Symbol() + "Status", 0) >= 0) { ObjectDelete(objName); }  
         if (StringFind(objName,Symbol() + "Comment", 0) >= 0) { ObjectDelete(objName); } 
      }
   }
}

void SetupLabels()
{
     StatusY = Y_OffSet;
     Comment1Y = StatusY + TxtSize + 4;
     Comment2Y = Comment1Y + TxtSize + 4;
     Comment3Y = Comment2Y + TxtSize + 4;
     Comment4Y = Comment3Y + TxtSize + 4;
     Comment5Y = Comment4Y + TxtSize + 4;
     Comment6Y = Comment5Y + TxtSize + 4;
     Comment7Y = Comment6Y + TxtSize + 4;
	  StatusLabel = Symbol() + "Status";
	  Comment1Label = Symbol() + "Comment1";
	  Comment2Label = Symbol() + "Comment2";
	  Comment3Label = Symbol() + "Comment3";
	  Comment4Label = Symbol() + "Comment4";
	  Comment5Label = Symbol() + "Comment5";
	  Comment6Label = Symbol() + "Comment6";
	  Comment7Label = Symbol() + "Comment7";
}

void OutputLabelToChart(string LabelName, int LabelY, int LabelTxtSize, color LabelColor, string LabelStr)
{

  	if(ObjectFind(LabelName) != 0)
   {
   ObjectCreate(LabelName, OBJ_LABEL, 0, 0, 0);
	ObjectSet(LabelName, OBJPROP_CORNER, 0);
	ObjectSet(LabelName, OBJPROP_XDISTANCE, 20);
	ObjectSet(LabelName, OBJPROP_YDISTANCE, LabelY);
	}
	ObjectSetText(LabelName, LabelStr, LabelTxtSize, "Arial Bold", LabelColor);
}

void OutputStatusToChart(string mComment)
{
   OutputLabelToChart(StatusLabel, StatusY, TxtSize, TxtColor, mComment );
}

void OutputComment1ToChart(string mComment)
{
   OutputLabelToChart(Comment1Label, Comment1Y, TxtSize, TxtColor, mComment );
}

void OutputComment2ToChart(string mComment)
{
   OutputLabelToChart(Comment2Label, Comment2Y, TxtSize, TxtColor, mComment );
}

void OutputComment3ToChart(string mComment)
{
   OutputLabelToChart(Comment3Label, Comment3Y, TxtSize, TxtColor, mComment );
}

void OutputComment4ToChart(string mComment)
{
   OutputLabelToChart(Comment4Label, Comment4Y, TxtSize, TxtColor, mComment );
}

void OutputComment5ToChart(string mComment)
{
   OutputLabelToChart(Comment5Label, Comment5Y, TxtSize, TxtColor, mComment );
}

void OutputComment6ToChart(string mComment)
{
   OutputLabelToChart(Comment6Label, Comment6Y, TxtSize, TxtColor, mComment );
}

void OutputComment7ToChart(string mComment)
{
   OutputLabelToChart(Comment7Label, Comment7Y, TxtSize, TxtColor, mComment );
}
//+------------------------------------------------------------------+